import React, { Component } from "react";
import Button from 'react-bootstrap/Button';
import Modal from 'react-bootstrap/Modal';
import { connect } from "react-redux";
import { bindActionCreators } from "redux";

import * as degreeCoursemanagementActions from '../../actions/DegreeCourseManagementActions'

const mapStateToProps = state => {
    return {
        accessToken: state.AuthenticationReducer.accessToken,
        showDeleteDegreeCourseModal: state.DegreeCourseReducer.showDeleteDegreeCourseModal,
        deleteModalData: state.DegreeCourseReducer.deleteModalData
    };
}

class DeleteDegreeCourseModal extends Component {

    constructor(props) {
        super(props);

        this.handleClose = this.handleClose.bind(this);
        this.handlePushDelete = this.handlePushDelete.bind(this);
    }

    handleClose() {
        const { hideDeleteDegreeCourseModalAction } = this.props;
        hideDeleteDegreeCourseModalAction();
    }

    handlePushDelete(e) {
        e.preventDefault();
        const { pushDeleteDegreeCourseModalAction } = this.props;
        console.log(this.props.deleteModalData.userID)
        pushDeleteDegreeCourseModalAction(this.props.deleteModalData.userID, this.props.accessToken)
    }

    render() {

        var showModal = this.props.showDeleteDegreeCourseModal
        if (showModal === undefined) {
            showModal = false
        }
        let dialogID
        let name
        if (this.props.deleteModalData) {
            dialogID = this.props.deleteModalData.dialogID;
            name = this.props.deleteModalData.name;
        } else {
            dialogID = ""
            name = ""
        }

        return (
            <div className="modal show" id="UserManagementPageDeleteComponent" style={{ display: 'block', position: 'initial' }}>
                <Modal show={showModal} id={dialogID} onHide={this.handleClose}>
                    <Modal.Header closeButton>
                        <Modal.Title>Studiengang {name} löschen?</Modal.Title>
                    </Modal.Header>

                    <Modal.Body style={{ textAlign: 'left' }}>
                        <p>Soll Studiengang {name} gelöscht werden?</p>
                    </Modal.Body>

                    <Modal.Footer>
                        <Button variant="secondary" id="DeleteDialogCancelButton" onClick={this.handleClose}>Cancel</Button>
                        <Button variant="primary" id="DeleteDialogConfirmButton" onClick={this.handlePushDelete}>Delete</Button>
                    </Modal.Footer>
                </Modal>
            </div >
        )
    }
}


const mapDispatchToProps = dispatch => bindActionCreators({
    hideDeleteDegreeCourseModalAction: degreeCoursemanagementActions.getHideDeleteDegreeCourseModalAction,
    pushDeleteDegreeCourseModalAction: degreeCoursemanagementActions.deleteDegreeCourseWithID
}, dispatch)

const ConnectedDeleteDegreeCourseModal = connect(mapStateToProps, mapDispatchToProps)(DeleteDegreeCourseModal)
export default ConnectedDeleteDegreeCourseModal